package com.applayos.GroupLinkApplay;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.grouplinknetwork.GroupLink;
import com.grouplinknetwork.GrouplinkUserIdListener;

import android.content.Context;

import android.os.Handler;
import android.os.Looper;

import android.util.Log;
import java.util.logging.Logger;
import java.util.logging.Level;

/**
 * This class echoes a string called from JavaScript.
 */

public class GroupLinkApplay extends CordovaPlugin {

    private Context context;
    public static final String TAG = "GroupLinkApplay";
    public static Logger logger = Logger.getAnonymousLogger();

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (action.equals("echoTest")) {
            String mensagemAlerta = args.getString(0);
            this.echoMethod(mensagemAlerta, callbackContext);
            return true;
        }
        if (action.equals("getUserId")) {
            this.getUserIdMethod(callbackContext);
            return true;
        }
        if (action.equals("start")) {
            String tokenTexto = args.getString(0);
            this.startMethod(tokenTexto, callbackContext);
            return true;
        }
        return false;
    }

    private void getUserIdMethod(CallbackContext callbackContext) {
        context = cordova.getActivity().getApplicationContext();
        GroupLink.getUserId(context, new GrouplinkUserIdListener() {
          @Override
          public void onUserIdReceived(long userid) {
            Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> USER ID "+userid);
          }
        });
        callbackContext.success("ok");
    }

    private void echoMethod(String message, CallbackContext callbackContext) {
        if (message != null && message.length() > 0) {
            callbackContext.success(message);
        } else {
            callbackContext.error("Houve algum erro no texto");
        }
    }

    private void startMethod(String token, CallbackContext callbackContext) {
        try {
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Iniciando na Main Thread");
          // context = cordova.getActivity();
          this.cordova.getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run(){
              Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> START:try >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
              context = cordova.getActivity().getApplicationContext();
              GroupLink.register(context,token,true);
              callbackContext.success("GroupLink ok token: "+token);
              Log.e(TAG,"token: "+token);
              Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> FIM:try >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
            }
          });
          // Handler handler = new Handler(Looper.getMainLooper());
          // handler.post(new Runnable(){
          //
          // })
        }
        catch(Exception e) {
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> START:catch >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
          logger.log(Level.SEVERE, "Erro", e);
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> FIM:catch >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
          callbackContext.error("Ocorreu um erro com GroupLink");
        }
    }
}
